<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.smx.impl;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.OutputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.OutputStreamWriter;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.PrintWriter;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.StringWriter;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.Writer;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.math.BigInteger;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.math.BigFraction;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.math.ops.LongOperations;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.smx.iface.BigIntegerMatrix;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.smx.iface.BigIntegerRationalMatrix;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.smx.iface.DoubleMatrix;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.smx.iface.LongMatrix;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.smx.iface.LongRationalMatrix;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.smx.iface.ReadableBigIntegerMatrix;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.smx.iface.ReadableLongMatrix;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.smx.ops.MatrixOperations;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.smx.ops.matrix.LongMatrixOperations;<a name="line.53"></a>
<FONT color="green">054</FONT>    <a name="line.54"></a>
<FONT color="green">055</FONT>    /**<a name="line.55"></a>
<FONT color="green">056</FONT>     * The &lt;code&gt;DefaultLongMatrix&lt;/code&gt; is the default implementation of LongMatrix. It<a name="line.56"></a>
<FONT color="green">057</FONT>     * contains a 1-dimensional array with all the matrix values.<a name="line.57"></a>
<FONT color="green">058</FONT>     */<a name="line.58"></a>
<FONT color="green">059</FONT>    public class DefaultLongMatrix implements LongMatrix {<a name="line.59"></a>
<FONT color="green">060</FONT>        <a name="line.60"></a>
<FONT color="green">061</FONT>        private static final String NL = System.getProperty("line.separator");<a name="line.61"></a>
<FONT color="green">062</FONT>    <a name="line.62"></a>
<FONT color="green">063</FONT>        private int         mColumnCount;<a name="line.63"></a>
<FONT color="green">064</FONT>        private long[]      mValues;<a name="line.64"></a>
<FONT color="green">065</FONT>        <a name="line.65"></a>
<FONT color="green">066</FONT>        public DefaultLongMatrix(int rowCount, int colCount) {<a name="line.66"></a>
<FONT color="green">067</FONT>            this(new long[rowCount * colCount], rowCount, colCount);<a name="line.67"></a>
<FONT color="green">068</FONT>        }<a name="line.68"></a>
<FONT color="green">069</FONT>        <a name="line.69"></a>
<FONT color="green">070</FONT>        public DefaultLongMatrix(long[] values, int rowCount, int columnCount) {<a name="line.70"></a>
<FONT color="green">071</FONT>            if (rowCount == -1) rowCount = values.length / columnCount;<a name="line.71"></a>
<FONT color="green">072</FONT>            if (columnCount == -1) columnCount = values.length / rowCount;<a name="line.72"></a>
<FONT color="green">073</FONT>            if (rowCount &lt; 0 || columnCount &lt; 0 || rowCount * columnCount != values.length) {<a name="line.73"></a>
<FONT color="green">074</FONT>                throw new IllegalArgumentException(<a name="line.74"></a>
<FONT color="green">075</FONT>                        "rowCount (" + rowCount + ") * columnCount (" + columnCount + <a name="line.75"></a>
<FONT color="green">076</FONT>                        ") != number of values (" + values.length + ")"<a name="line.76"></a>
<FONT color="green">077</FONT>                        );<a name="line.77"></a>
<FONT color="green">078</FONT>            }<a name="line.78"></a>
<FONT color="green">079</FONT>            mValues                 = values;<a name="line.79"></a>
<FONT color="green">080</FONT>            mColumnCount    = columnCount;<a name="line.80"></a>
<FONT color="green">081</FONT>        }<a name="line.81"></a>
<FONT color="green">082</FONT>        <a name="line.82"></a>
<FONT color="green">083</FONT>        /**<a name="line.83"></a>
<FONT color="green">084</FONT>         * Initializes the matrix from a 2-dim long array. The resulting<a name="line.84"></a>
<FONT color="green">085</FONT>         * rows relate to the first dimension if &lt;code&gt;rowsInDim1&lt;/code&gt; is<a name="line.85"></a>
<FONT color="green">086</FONT>         * true, or to the second dimension otherwise. <a name="line.86"></a>
<FONT color="green">087</FONT>         * If the second dimension has different lengths, the maximum value<a name="line.87"></a>
<FONT color="green">088</FONT>         * is taken, missing values are initialized with 0.<a name="line.88"></a>
<FONT color="green">089</FONT>         * <a name="line.89"></a>
<FONT color="green">090</FONT>         * @param values            The 2-dim long array with the source values<a name="line.90"></a>
<FONT color="green">091</FONT>         * @param rowsInDim1        If true, the 1&lt;sup&gt;st&lt;/sup&gt; dimension will become<a name="line.91"></a>
<FONT color="green">092</FONT>         *                                          rows in the resulting &lt;code&gt;DefaultDoubleMatrix&lt;/code&gt;,<a name="line.92"></a>
<FONT color="green">093</FONT>         *                                          the columns relate to the 2&lt;sup&gt;nd&lt;/sup&gt; dimension.<a name="line.93"></a>
<FONT color="green">094</FONT>         *                                          If false, it is vice versa.<a name="line.94"></a>
<FONT color="green">095</FONT>         */<a name="line.95"></a>
<FONT color="green">096</FONT>        public DefaultLongMatrix(long[][] values, boolean rowsInDim1) {<a name="line.96"></a>
<FONT color="green">097</FONT>            int rowCnt, colCnt;<a name="line.97"></a>
<FONT color="green">098</FONT>            if (rowsInDim1) {<a name="line.98"></a>
<FONT color="green">099</FONT>                    rowCnt = values.length;<a name="line.99"></a>
<FONT color="green">100</FONT>                    colCnt = 0;<a name="line.100"></a>
<FONT color="green">101</FONT>                    for (int row = 0; row &lt; values.length; row++) {<a name="line.101"></a>
<FONT color="green">102</FONT>                                    colCnt = Math.max(colCnt, values[row].length);<a name="line.102"></a>
<FONT color="green">103</FONT>                            }<a name="line.103"></a>
<FONT color="green">104</FONT>            }<a name="line.104"></a>
<FONT color="green">105</FONT>            else {<a name="line.105"></a>
<FONT color="green">106</FONT>                    colCnt = values.length;<a name="line.106"></a>
<FONT color="green">107</FONT>                    rowCnt = 0;<a name="line.107"></a>
<FONT color="green">108</FONT>                    for (int col = 0; col &lt; values.length; col++) {<a name="line.108"></a>
<FONT color="green">109</FONT>                                    rowCnt = Math.max(rowCnt, values[col].length);<a name="line.109"></a>
<FONT color="green">110</FONT>                            }<a name="line.110"></a>
<FONT color="green">111</FONT>            }<a name="line.111"></a>
<FONT color="green">112</FONT>            final long[] vals = new long[rowCnt * colCnt];<a name="line.112"></a>
<FONT color="green">113</FONT>            for (int row = 0; row &lt; rowCnt; row++) {<a name="line.113"></a>
<FONT color="green">114</FONT>                            for (int col = 0; col &lt; colCnt; col++) {<a name="line.114"></a>
<FONT color="green">115</FONT>                                    int index1 = rowsInDim1 ? row : col;<a name="line.115"></a>
<FONT color="green">116</FONT>                                    int index2 = rowsInDim1 ? col : row;<a name="line.116"></a>
<FONT color="green">117</FONT>                                    vals[row * colCnt + col] = <a name="line.117"></a>
<FONT color="green">118</FONT>                                            index2 &lt; values[index1].length ? values[index1][index2] : 0;<a name="line.118"></a>
<FONT color="green">119</FONT>                            }<a name="line.119"></a>
<FONT color="green">120</FONT>                    }<a name="line.120"></a>
<FONT color="green">121</FONT>            mValues                 = vals;<a name="line.121"></a>
<FONT color="green">122</FONT>            mColumnCount    = colCnt;<a name="line.122"></a>
<FONT color="green">123</FONT>        }<a name="line.123"></a>
<FONT color="green">124</FONT>        /**<a name="line.124"></a>
<FONT color="green">125</FONT>         * Initializes the matrix from a 2-dim long array. The resulting<a name="line.125"></a>
<FONT color="green">126</FONT>         * rows relate to the first dimension if &lt;code&gt;rowsInDim1&lt;/code&gt; is<a name="line.126"></a>
<FONT color="green">127</FONT>         * true, or to the second dimension otherwise. <a name="line.127"></a>
<FONT color="green">128</FONT>         * If the second dimension has different lengths, the maximum value<a name="line.128"></a>
<FONT color="green">129</FONT>         * is taken, missing values are initialized with 0.<a name="line.129"></a>
<FONT color="green">130</FONT>         * <a name="line.130"></a>
<FONT color="green">131</FONT>         * @param values            The 2-dim long array with the source values<a name="line.131"></a>
<FONT color="green">132</FONT>         * @param rowsInDim1        If true, the 1&lt;sup&gt;st&lt;/sup&gt; dimension will become<a name="line.132"></a>
<FONT color="green">133</FONT>         *                                          rows in the resulting &lt;code&gt;DefaultDoubleMatrix&lt;/code&gt;,<a name="line.133"></a>
<FONT color="green">134</FONT>         *                                          the columns relate to the 2&lt;sup&gt;nd&lt;/sup&gt; dimension.<a name="line.134"></a>
<FONT color="green">135</FONT>         *                                          If false, it is vice versa.<a name="line.135"></a>
<FONT color="green">136</FONT>         */<a name="line.136"></a>
<FONT color="green">137</FONT>        public DefaultLongMatrix(Long[][] values, boolean rowsInDim1) {<a name="line.137"></a>
<FONT color="green">138</FONT>            int rowCnt, colCnt;<a name="line.138"></a>
<FONT color="green">139</FONT>            if (rowsInDim1) {<a name="line.139"></a>
<FONT color="green">140</FONT>                    rowCnt = values.length;<a name="line.140"></a>
<FONT color="green">141</FONT>                    colCnt = 0;<a name="line.141"></a>
<FONT color="green">142</FONT>                    for (int row = 0; row &lt; values.length; row++) {<a name="line.142"></a>
<FONT color="green">143</FONT>                                    colCnt = Math.max(colCnt, values[row].length);<a name="line.143"></a>
<FONT color="green">144</FONT>                            }<a name="line.144"></a>
<FONT color="green">145</FONT>            }<a name="line.145"></a>
<FONT color="green">146</FONT>            else {<a name="line.146"></a>
<FONT color="green">147</FONT>                    colCnt = values.length;<a name="line.147"></a>
<FONT color="green">148</FONT>                    rowCnt = 0;<a name="line.148"></a>
<FONT color="green">149</FONT>                    for (int col = 0; col &lt; values.length; col++) {<a name="line.149"></a>
<FONT color="green">150</FONT>                                    rowCnt = Math.max(rowCnt, values[col].length);<a name="line.150"></a>
<FONT color="green">151</FONT>                            }<a name="line.151"></a>
<FONT color="green">152</FONT>            }<a name="line.152"></a>
<FONT color="green">153</FONT>            final long[] vals = new long[rowCnt * colCnt];<a name="line.153"></a>
<FONT color="green">154</FONT>            for (int row = 0; row &lt; rowCnt; row++) {<a name="line.154"></a>
<FONT color="green">155</FONT>                            for (int col = 0; col &lt; colCnt; col++) {<a name="line.155"></a>
<FONT color="green">156</FONT>                                    int index1 = rowsInDim1 ? row : col;<a name="line.156"></a>
<FONT color="green">157</FONT>                                    int index2 = rowsInDim1 ? col : row;<a name="line.157"></a>
<FONT color="green">158</FONT>                                    vals[row * colCnt + col] = <a name="line.158"></a>
<FONT color="green">159</FONT>                                            index2 &lt; values[index1].length ? values[index1][index2].longValue() : 0;<a name="line.159"></a>
<FONT color="green">160</FONT>                            }<a name="line.160"></a>
<FONT color="green">161</FONT>                    }<a name="line.161"></a>
<FONT color="green">162</FONT>            mValues                 = vals;<a name="line.162"></a>
<FONT color="green">163</FONT>            mColumnCount    = colCnt;<a name="line.163"></a>
<FONT color="green">164</FONT>        }<a name="line.164"></a>
<FONT color="green">165</FONT>        public DefaultLongMatrix(ReadableLongMatrix mx) {<a name="line.165"></a>
<FONT color="green">166</FONT>            mValues                 = mx.toLongArray();<a name="line.166"></a>
<FONT color="green">167</FONT>            mColumnCount    = mx.getColumnCount();<a name="line.167"></a>
<FONT color="green">168</FONT>        }<a name="line.168"></a>
<FONT color="green">169</FONT>        <a name="line.169"></a>
<FONT color="green">170</FONT>        public static DefaultLongMatrix diag(long[] values) {<a name="line.170"></a>
<FONT color="green">171</FONT>            final int len = values.length;<a name="line.171"></a>
<FONT color="green">172</FONT>            DefaultLongMatrix mx = new DefaultLongMatrix(new long[len * len], len, len);<a name="line.172"></a>
<FONT color="green">173</FONT>            for (int ii = 0; ii &lt; len; ii++) {<a name="line.173"></a>
<FONT color="green">174</FONT>                mx.setValueAt(ii, ii, values[ii]);<a name="line.174"></a>
<FONT color="green">175</FONT>            }<a name="line.175"></a>
<FONT color="green">176</FONT>            return mx;<a name="line.176"></a>
<FONT color="green">177</FONT>        }<a name="line.177"></a>
<FONT color="green">178</FONT>        <a name="line.178"></a>
<FONT color="green">179</FONT>        public static DefaultLongMatrix diag(long value, int len) {<a name="line.179"></a>
<FONT color="green">180</FONT>            final DefaultLongMatrix mx = new DefaultLongMatrix(new long[len * len], len, len);<a name="line.180"></a>
<FONT color="green">181</FONT>            for (int ii = 0; ii &lt; len; ii++) {<a name="line.181"></a>
<FONT color="green">182</FONT>                mx.setValueAt(ii, ii, value);<a name="line.182"></a>
<FONT color="green">183</FONT>            }<a name="line.183"></a>
<FONT color="green">184</FONT>            return mx;        <a name="line.184"></a>
<FONT color="green">185</FONT>        }<a name="line.185"></a>
<FONT color="green">186</FONT>        <a name="line.186"></a>
<FONT color="green">187</FONT>        public static DefaultLongMatrix identity(int len) {<a name="line.187"></a>
<FONT color="green">188</FONT>            return diag(1, len);<a name="line.188"></a>
<FONT color="green">189</FONT>        }<a name="line.189"></a>
<FONT color="green">190</FONT>        <a name="line.190"></a>
<FONT color="green">191</FONT>        public LongOperations getNumberOperations() {<a name="line.191"></a>
<FONT color="green">192</FONT>            return LongOperations.instance();<a name="line.192"></a>
<FONT color="green">193</FONT>        }<a name="line.193"></a>
<FONT color="green">194</FONT>        <a name="line.194"></a>
<FONT color="green">195</FONT>        public MatrixOperations&lt;Long&gt; getMatrixOperations() {<a name="line.195"></a>
<FONT color="green">196</FONT>            return LongMatrixOperations.instance();<a name="line.196"></a>
<FONT color="green">197</FONT>        }<a name="line.197"></a>
<FONT color="green">198</FONT>    <a name="line.198"></a>
<FONT color="green">199</FONT>        public long getLongValueAt(int row, int col) {<a name="line.199"></a>
<FONT color="green">200</FONT>            return mValues[row * mColumnCount + col];<a name="line.200"></a>
<FONT color="green">201</FONT>        }<a name="line.201"></a>
<FONT color="green">202</FONT>    <a name="line.202"></a>
<FONT color="green">203</FONT>        public int getSignumAt(int row, int col) {          <a name="line.203"></a>
<FONT color="green">204</FONT>            final long val = getLongValueAt(row, col);<a name="line.204"></a>
<FONT color="green">205</FONT>            return val == 0 ? 0 : val &lt; 0d ? -1 : 1;<a name="line.205"></a>
<FONT color="green">206</FONT>        }<a name="line.206"></a>
<FONT color="green">207</FONT>    <a name="line.207"></a>
<FONT color="green">208</FONT>        public long getLongNumeratorAt(int row, int col) {<a name="line.208"></a>
<FONT color="green">209</FONT>            return getLongValueAt(row, col);<a name="line.209"></a>
<FONT color="green">210</FONT>        }<a name="line.210"></a>
<FONT color="green">211</FONT>        <a name="line.211"></a>
<FONT color="green">212</FONT>        public long getLongDenominatorAt(int row, int col) {<a name="line.212"></a>
<FONT color="green">213</FONT>            return 1L;<a name="line.213"></a>
<FONT color="green">214</FONT>        }<a name="line.214"></a>
<FONT color="green">215</FONT>        <a name="line.215"></a>
<FONT color="green">216</FONT>        public BigInteger getBigIntegerNumeratorAt(int row, int col) {<a name="line.216"></a>
<FONT color="green">217</FONT>            return BigInteger.valueOf(getLongNumeratorAt(row, col));<a name="line.217"></a>
<FONT color="green">218</FONT>        }<a name="line.218"></a>
<FONT color="green">219</FONT>        <a name="line.219"></a>
<FONT color="green">220</FONT>        public BigInteger getBigIntegerDenominatorAt(int row, int col) {<a name="line.220"></a>
<FONT color="green">221</FONT>            return BigInteger.ONE;<a name="line.221"></a>
<FONT color="green">222</FONT>        }<a name="line.222"></a>
<FONT color="green">223</FONT>    <a name="line.223"></a>
<FONT color="green">224</FONT>        public double getDoubleValueAt(int row, int col) {<a name="line.224"></a>
<FONT color="green">225</FONT>            return getLongValueAt(row, col);<a name="line.225"></a>
<FONT color="green">226</FONT>        }<a name="line.226"></a>
<FONT color="green">227</FONT>        <a name="line.227"></a>
<FONT color="green">228</FONT>        public BigFraction getBigFractionValueAt(int row, int col) {<a name="line.228"></a>
<FONT color="green">229</FONT>            return new BigFraction(<a name="line.229"></a>
<FONT color="green">230</FONT>                    getBigIntegerNumeratorAt(row, col), getBigIntegerDenominatorAt(row, col)<a name="line.230"></a>
<FONT color="green">231</FONT>            );<a name="line.231"></a>
<FONT color="green">232</FONT>        }<a name="line.232"></a>
<FONT color="green">233</FONT>    <a name="line.233"></a>
<FONT color="green">234</FONT>        public int getRowCount() {<a name="line.234"></a>
<FONT color="green">235</FONT>            return mColumnCount &gt; 0 ? mValues.length / mColumnCount : 0;<a name="line.235"></a>
<FONT color="green">236</FONT>        }<a name="line.236"></a>
<FONT color="green">237</FONT>    <a name="line.237"></a>
<FONT color="green">238</FONT>        public int getColumnCount() {<a name="line.238"></a>
<FONT color="green">239</FONT>            return mColumnCount;<a name="line.239"></a>
<FONT color="green">240</FONT>        }<a name="line.240"></a>
<FONT color="green">241</FONT>    <a name="line.241"></a>
<FONT color="green">242</FONT>        public void setValueAt(int row, int col, int value) {<a name="line.242"></a>
<FONT color="green">243</FONT>            mValues[row * mColumnCount + col] = value;<a name="line.243"></a>
<FONT color="green">244</FONT>        }<a name="line.244"></a>
<FONT color="green">245</FONT>        public void setValueAt(int row, int col, long value) {<a name="line.245"></a>
<FONT color="green">246</FONT>            mValues[row * mColumnCount + col] = value;<a name="line.246"></a>
<FONT color="green">247</FONT>        }<a name="line.247"></a>
<FONT color="green">248</FONT>        public void setValueAt(int row, int col, Integer value) {<a name="line.248"></a>
<FONT color="green">249</FONT>            setValueAt(row, col, value.intValue());<a name="line.249"></a>
<FONT color="green">250</FONT>        }<a name="line.250"></a>
<FONT color="green">251</FONT>        public void setValueAt(int row, int col, Long value) {<a name="line.251"></a>
<FONT color="green">252</FONT>            setValueAt(row, col, value.longValue());<a name="line.252"></a>
<FONT color="green">253</FONT>        }<a name="line.253"></a>
<FONT color="green">254</FONT>    <a name="line.254"></a>
<FONT color="green">255</FONT>        /* (non-Javadoc)<a name="line.255"></a>
<FONT color="green">256</FONT>         * @see ch.javasoft.smx.iface.WritableMatrix#swapRows(int, int)<a name="line.256"></a>
<FONT color="green">257</FONT>         */<a name="line.257"></a>
<FONT color="green">258</FONT>        public void swapRows(int rowA, int rowB) {<a name="line.258"></a>
<FONT color="green">259</FONT>            if (rowA == rowB) return;<a name="line.259"></a>
<FONT color="green">260</FONT>            final long[] tmpRow = new long[mColumnCount];<a name="line.260"></a>
<FONT color="green">261</FONT>            System.arraycopy(mValues, rowA * mColumnCount, tmpRow, 0, mColumnCount);<a name="line.261"></a>
<FONT color="green">262</FONT>            System.arraycopy(mValues, rowB * mColumnCount, mValues, rowA * mColumnCount, mColumnCount);<a name="line.262"></a>
<FONT color="green">263</FONT>            System.arraycopy(tmpRow, 0, mValues, rowB * mColumnCount, mColumnCount);        <a name="line.263"></a>
<FONT color="green">264</FONT>        }<a name="line.264"></a>
<FONT color="green">265</FONT>    <a name="line.265"></a>
<FONT color="green">266</FONT>        public void swapColumns(int colA, int colB) {<a name="line.266"></a>
<FONT color="green">267</FONT>            if (colA != colB) {<a name="line.267"></a>
<FONT color="green">268</FONT>                    int rows = getRowCount();<a name="line.268"></a>
<FONT color="green">269</FONT>                    for (int row = 0; row &lt; rows; row++) {<a name="line.269"></a>
<FONT color="green">270</FONT>                                    long tmp = getLongValueAt(row, colA);<a name="line.270"></a>
<FONT color="green">271</FONT>                                    setValueAt(row, colA, getLongValueAt(row, colB));<a name="line.271"></a>
<FONT color="green">272</FONT>                                    setValueAt(row, colB, tmp);<a name="line.272"></a>
<FONT color="green">273</FONT>                            }<a name="line.273"></a>
<FONT color="green">274</FONT>            }<a name="line.274"></a>
<FONT color="green">275</FONT>        }<a name="line.275"></a>
<FONT color="green">276</FONT>    <a name="line.276"></a>
<FONT color="green">277</FONT>        public Long getNumberValueAt(int row, int col) {<a name="line.277"></a>
<FONT color="green">278</FONT>            return Long.valueOf(getLongValueAt(row, col));<a name="line.278"></a>
<FONT color="green">279</FONT>        }<a name="line.279"></a>
<FONT color="green">280</FONT>        <a name="line.280"></a>
<FONT color="green">281</FONT>        public void toArray(long[] array) {<a name="line.281"></a>
<FONT color="green">282</FONT>            if (array.length != mValues.length) {<a name="line.282"></a>
<FONT color="green">283</FONT>                throw new IllegalArgumentException("expected array length " + mValues.length + " but found " + array.length);<a name="line.283"></a>
<FONT color="green">284</FONT>            }<a name="line.284"></a>
<FONT color="green">285</FONT>            System.arraycopy(mValues, 0, array, 0, array.length);<a name="line.285"></a>
<FONT color="green">286</FONT>        }<a name="line.286"></a>
<FONT color="green">287</FONT>        public static void toArray(ReadableLongMatrix mx, long[] array) {<a name="line.287"></a>
<FONT color="green">288</FONT>            final  int rows = mx.getRowCount();<a name="line.288"></a>
<FONT color="green">289</FONT>            final int cols = mx.getColumnCount();<a name="line.289"></a>
<FONT color="green">290</FONT>            if (array.length != rows * cols) {<a name="line.290"></a>
<FONT color="green">291</FONT>                throw new IllegalArgumentException("expected array length " + (rows * cols) + " but found " + array.length);<a name="line.291"></a>
<FONT color="green">292</FONT>            }<a name="line.292"></a>
<FONT color="green">293</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.293"></a>
<FONT color="green">294</FONT>                for (int col = 0; col &lt; cols; col++) {<a name="line.294"></a>
<FONT color="green">295</FONT>                    array[row * cols + col] = mx.getLongValueAt(row, col);<a name="line.295"></a>
<FONT color="green">296</FONT>                }<a name="line.296"></a>
<FONT color="green">297</FONT>            }<a name="line.297"></a>
<FONT color="green">298</FONT>        }<a name="line.298"></a>
<FONT color="green">299</FONT>        <a name="line.299"></a>
<FONT color="green">300</FONT>        public double[] toDoubleArray() {<a name="line.300"></a>
<FONT color="green">301</FONT>            final double[] array = new double[mValues.length];<a name="line.301"></a>
<FONT color="green">302</FONT>            toArray(array);<a name="line.302"></a>
<FONT color="green">303</FONT>            return array;<a name="line.303"></a>
<FONT color="green">304</FONT>        }<a name="line.304"></a>
<FONT color="green">305</FONT>        <a name="line.305"></a>
<FONT color="green">306</FONT>        public long[] toLongArray() {<a name="line.306"></a>
<FONT color="green">307</FONT>            final long[] array = new long[mValues.length];<a name="line.307"></a>
<FONT color="green">308</FONT>            toArray(array);<a name="line.308"></a>
<FONT color="green">309</FONT>            return array;<a name="line.309"></a>
<FONT color="green">310</FONT>        }<a name="line.310"></a>
<FONT color="green">311</FONT>        <a name="line.311"></a>
<FONT color="green">312</FONT>        public void toArray(double[] array) {<a name="line.312"></a>
<FONT color="green">313</FONT>            AbstractDoubleMatrix.toArray(this, array);<a name="line.313"></a>
<FONT color="green">314</FONT>        }<a name="line.314"></a>
<FONT color="green">315</FONT>        <a name="line.315"></a>
<FONT color="green">316</FONT>        public double[] getDoubleColumn(int col) {<a name="line.316"></a>
<FONT color="green">317</FONT>            return AbstractDoubleMatrix.getDoubleColumn(this, col);<a name="line.317"></a>
<FONT color="green">318</FONT>        }<a name="line.318"></a>
<FONT color="green">319</FONT>        <a name="line.319"></a>
<FONT color="green">320</FONT>        public double[][] getDoubleColumns() {<a name="line.320"></a>
<FONT color="green">321</FONT>            return AbstractDoubleMatrix.getDoubleColumns(this);<a name="line.321"></a>
<FONT color="green">322</FONT>        }<a name="line.322"></a>
<FONT color="green">323</FONT>        <a name="line.323"></a>
<FONT color="green">324</FONT>        public double[] getDoubleRow(int row) {<a name="line.324"></a>
<FONT color="green">325</FONT>            return AbstractDoubleMatrix.getDoubleRow(this, row);<a name="line.325"></a>
<FONT color="green">326</FONT>        }<a name="line.326"></a>
<FONT color="green">327</FONT>        <a name="line.327"></a>
<FONT color="green">328</FONT>        public double[][] getDoubleRows() {<a name="line.328"></a>
<FONT color="green">329</FONT>            return AbstractDoubleMatrix.getDoubleRows(this);<a name="line.329"></a>
<FONT color="green">330</FONT>        }<a name="line.330"></a>
<FONT color="green">331</FONT>    <a name="line.331"></a>
<FONT color="green">332</FONT>        public long[] getLongColumn(int col) {<a name="line.332"></a>
<FONT color="green">333</FONT>            return getLongColumn(this, col);<a name="line.333"></a>
<FONT color="green">334</FONT>        }<a name="line.334"></a>
<FONT color="green">335</FONT>        public static long[] getLongColumn(ReadableLongMatrix mx, int col) {<a name="line.335"></a>
<FONT color="green">336</FONT>            final int rows = mx.getRowCount();<a name="line.336"></a>
<FONT color="green">337</FONT>            final long[] res = new long[rows];<a name="line.337"></a>
<FONT color="green">338</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.338"></a>
<FONT color="green">339</FONT>                res[row] = mx.getLongValueAt(row, col);            <a name="line.339"></a>
<FONT color="green">340</FONT>            }<a name="line.340"></a>
<FONT color="green">341</FONT>            return res;<a name="line.341"></a>
<FONT color="green">342</FONT>        }<a name="line.342"></a>
<FONT color="green">343</FONT>        public long[] getLongRow(int row) {<a name="line.343"></a>
<FONT color="green">344</FONT>            return getLongRow(this, row);<a name="line.344"></a>
<FONT color="green">345</FONT>        }<a name="line.345"></a>
<FONT color="green">346</FONT>        public static long[] getLongRow(ReadableLongMatrix mx, int row) {<a name="line.346"></a>
<FONT color="green">347</FONT>            final int cols = mx.getColumnCount();<a name="line.347"></a>
<FONT color="green">348</FONT>            final long[] res = new long[cols];<a name="line.348"></a>
<FONT color="green">349</FONT>            for (int col = 0; col &lt; cols; col++) {<a name="line.349"></a>
<FONT color="green">350</FONT>                res[col] = mx.getLongValueAt(row, col);<a name="line.350"></a>
<FONT color="green">351</FONT>            }<a name="line.351"></a>
<FONT color="green">352</FONT>            return res;<a name="line.352"></a>
<FONT color="green">353</FONT>        }<a name="line.353"></a>
<FONT color="green">354</FONT>        <a name="line.354"></a>
<FONT color="green">355</FONT>        public long[][] getLongColumns() {<a name="line.355"></a>
<FONT color="green">356</FONT>            return getLongColumns(this);<a name="line.356"></a>
<FONT color="green">357</FONT>        }<a name="line.357"></a>
<FONT color="green">358</FONT>        public static long[][] getLongColumns(ReadableLongMatrix mx) {<a name="line.358"></a>
<FONT color="green">359</FONT>            final int cols = mx.getColumnCount();<a name="line.359"></a>
<FONT color="green">360</FONT>            final long[][] res = new long[cols][];<a name="line.360"></a>
<FONT color="green">361</FONT>            for (int col = 0; col &lt; cols; col++) {<a name="line.361"></a>
<FONT color="green">362</FONT>                res[col] = mx.getLongColumn(col);<a name="line.362"></a>
<FONT color="green">363</FONT>            }<a name="line.363"></a>
<FONT color="green">364</FONT>            return res;<a name="line.364"></a>
<FONT color="green">365</FONT>        }<a name="line.365"></a>
<FONT color="green">366</FONT>        <a name="line.366"></a>
<FONT color="green">367</FONT>        public long[][] getLongRows() {<a name="line.367"></a>
<FONT color="green">368</FONT>            return getLongRows(this);<a name="line.368"></a>
<FONT color="green">369</FONT>        }<a name="line.369"></a>
<FONT color="green">370</FONT>        public static long[][] getLongRows(ReadableLongMatrix mx) {<a name="line.370"></a>
<FONT color="green">371</FONT>            final int rows = mx.getRowCount();<a name="line.371"></a>
<FONT color="green">372</FONT>            final long[][] res = new long[rows][];<a name="line.372"></a>
<FONT color="green">373</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.373"></a>
<FONT color="green">374</FONT>                res[row] = mx.getLongRow(row);<a name="line.374"></a>
<FONT color="green">375</FONT>            }<a name="line.375"></a>
<FONT color="green">376</FONT>            return res;<a name="line.376"></a>
<FONT color="green">377</FONT>        }<a name="line.377"></a>
<FONT color="green">378</FONT>        <a name="line.378"></a>
<FONT color="green">379</FONT>        public Long[][] getNumberRows() {<a name="line.379"></a>
<FONT color="green">380</FONT>            return getNumberRows(this);<a name="line.380"></a>
<FONT color="green">381</FONT>        }<a name="line.381"></a>
<FONT color="green">382</FONT>        public static Long[][] getNumberRows(ReadableLongMatrix&lt;Long&gt; mx) {<a name="line.382"></a>
<FONT color="green">383</FONT>            final int rows = mx.getRowCount();<a name="line.383"></a>
<FONT color="green">384</FONT>            final int cols = mx.getColumnCount();<a name="line.384"></a>
<FONT color="green">385</FONT>            final Long[][] data = new Long[rows][cols];<a name="line.385"></a>
<FONT color="green">386</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.386"></a>
<FONT color="green">387</FONT>                            for (int col = 0; col &lt; cols; col++) {<a name="line.387"></a>
<FONT color="green">388</FONT>                                    data[row][col] = Long.valueOf(mx.getLongValueAt(row, col));<a name="line.388"></a>
<FONT color="green">389</FONT>                            }<a name="line.389"></a>
<FONT color="green">390</FONT>                    }<a name="line.390"></a>
<FONT color="green">391</FONT>            return data;<a name="line.391"></a>
<FONT color="green">392</FONT>        }<a name="line.392"></a>
<FONT color="green">393</FONT>        <a name="line.393"></a>
<FONT color="green">394</FONT>    <a name="line.394"></a>
<FONT color="green">395</FONT>        @Override<a name="line.395"></a>
<FONT color="green">396</FONT>            public String toString() {<a name="line.396"></a>
<FONT color="green">397</FONT>            return toString(this);<a name="line.397"></a>
<FONT color="green">398</FONT>        }<a name="line.398"></a>
<FONT color="green">399</FONT>        public void writeTo(Writer writer) {<a name="line.399"></a>
<FONT color="green">400</FONT>            writeTo(writer, this);<a name="line.400"></a>
<FONT color="green">401</FONT>        }<a name="line.401"></a>
<FONT color="green">402</FONT>        public void writeTo(OutputStream out) {<a name="line.402"></a>
<FONT color="green">403</FONT>            writeTo(out, this);<a name="line.403"></a>
<FONT color="green">404</FONT>        }<a name="line.404"></a>
<FONT color="green">405</FONT>        public static String toString(ReadableLongMatrix mx) {<a name="line.405"></a>
<FONT color="green">406</FONT>            return toString(mx, "{", " }", " [", "]", "", "", "", ", ");<a name="line.406"></a>
<FONT color="green">407</FONT>        }<a name="line.407"></a>
<FONT color="green">408</FONT>        public static void writeTo(Writer writer, ReadableLongMatrix mx) {<a name="line.408"></a>
<FONT color="green">409</FONT>            writeTo(<a name="line.409"></a>
<FONT color="green">410</FONT>                    writer instanceof PrintWriter ? (PrintWriter)writer: new PrintWriter(writer), <a name="line.410"></a>
<FONT color="green">411</FONT>                    mx, "{", " }", " [", "]", "", "", "", ", ");        <a name="line.411"></a>
<FONT color="green">412</FONT>        }<a name="line.412"></a>
<FONT color="green">413</FONT>        public static void writeTo(OutputStream out, ReadableLongMatrix mx) {<a name="line.413"></a>
<FONT color="green">414</FONT>            writeTo(<a name="line.414"></a>
<FONT color="green">415</FONT>                    new PrintWriter(new OutputStreamWriter(out)), <a name="line.415"></a>
<FONT color="green">416</FONT>                    mx, "{", " }", " [", "]", "", "", "", ", ");        <a name="line.416"></a>
<FONT color="green">417</FONT>        }    <a name="line.417"></a>
<FONT color="green">418</FONT>        <a name="line.418"></a>
<FONT color="green">419</FONT>        public String toMultilineString() {<a name="line.419"></a>
<FONT color="green">420</FONT>            return toMultilineString(this);<a name="line.420"></a>
<FONT color="green">421</FONT>        }<a name="line.421"></a>
<FONT color="green">422</FONT>        public void writeToMultiline(Writer writer) {<a name="line.422"></a>
<FONT color="green">423</FONT>            writeToMultiline(writer, this);<a name="line.423"></a>
<FONT color="green">424</FONT>        }<a name="line.424"></a>
<FONT color="green">425</FONT>        public void writeToMultiline(OutputStream out) {<a name="line.425"></a>
<FONT color="green">426</FONT>            writeToMultiline(out, this);<a name="line.426"></a>
<FONT color="green">427</FONT>        }<a name="line.427"></a>
<FONT color="green">428</FONT>        public static String toMultilineString(ReadableLongMatrix mx) {<a name="line.428"></a>
<FONT color="green">429</FONT>            return toString(mx, "{" + NL, "}" + NL, " [", "]" + NL, "", " ", " ", ",");<a name="line.429"></a>
<FONT color="green">430</FONT>        }<a name="line.430"></a>
<FONT color="green">431</FONT>        public static void writeToMultiline(Writer writer, ReadableLongMatrix mx) {<a name="line.431"></a>
<FONT color="green">432</FONT>            writeTo(<a name="line.432"></a>
<FONT color="green">433</FONT>                    writer instanceof PrintWriter ? (PrintWriter)writer: new PrintWriter(writer), <a name="line.433"></a>
<FONT color="green">434</FONT>                    mx, "{" + NL, "}" + NL, " [", "]" + NL, "", " ", " ", ",");        <a name="line.434"></a>
<FONT color="green">435</FONT>        }<a name="line.435"></a>
<FONT color="green">436</FONT>        public static void writeToMultiline(OutputStream out, ReadableLongMatrix mx) {<a name="line.436"></a>
<FONT color="green">437</FONT>            writeTo(<a name="line.437"></a>
<FONT color="green">438</FONT>                    new PrintWriter(new OutputStreamWriter(out)), <a name="line.438"></a>
<FONT color="green">439</FONT>                    mx, "{" + NL, "}" + NL, " [", "]" + NL, "", " ", " ", ",");        <a name="line.439"></a>
<FONT color="green">440</FONT>        }    <a name="line.440"></a>
<FONT color="green">441</FONT>        <a name="line.441"></a>
<FONT color="green">442</FONT>        protected static String toString(ReadableLongMatrix mx, String prefix, String postfix, String rowPrefix, String rowPostfix, String rowSeparator, String colPrefix, String colPostfix, String colSeparator) {<a name="line.442"></a>
<FONT color="green">443</FONT>            StringWriter sw = new StringWriter();<a name="line.443"></a>
<FONT color="green">444</FONT>            writeTo(new PrintWriter(sw), mx, prefix, postfix, rowPrefix, rowPostfix, rowSeparator, colPrefix, colPostfix, colSeparator);<a name="line.444"></a>
<FONT color="green">445</FONT>            return sw.toString();<a name="line.445"></a>
<FONT color="green">446</FONT>        }<a name="line.446"></a>
<FONT color="green">447</FONT>        protected static void writeTo(PrintWriter writer, ReadableLongMatrix mx, String prefix, String postfix, String rowPrefix, String rowPostfix, String rowSeparator, String colPrefix, String colPostfix, String colSeparator) {<a name="line.447"></a>
<FONT color="green">448</FONT>            final int rows = mx.getRowCount();<a name="line.448"></a>
<FONT color="green">449</FONT>            final int cols = mx.getColumnCount();<a name="line.449"></a>
<FONT color="green">450</FONT>            writer.print(prefix);<a name="line.450"></a>
<FONT color="green">451</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.451"></a>
<FONT color="green">452</FONT>                if (row &gt; 0) writer.print(rowSeparator);<a name="line.452"></a>
<FONT color="green">453</FONT>                writer.print(rowPrefix);            <a name="line.453"></a>
<FONT color="green">454</FONT>                for (int col = 0; col &lt; cols; col++) {<a name="line.454"></a>
<FONT color="green">455</FONT>                    if (col &gt; 0) writer.print(colSeparator);<a name="line.455"></a>
<FONT color="green">456</FONT>                    writer.print(colPrefix);<a name="line.456"></a>
<FONT color="green">457</FONT>                    writer.print(mx.getLongValueAt(row, col));<a name="line.457"></a>
<FONT color="green">458</FONT>                    writer.print(colPostfix);<a name="line.458"></a>
<FONT color="green">459</FONT>                }<a name="line.459"></a>
<FONT color="green">460</FONT>                writer.print(rowPostfix);<a name="line.460"></a>
<FONT color="green">461</FONT>            }<a name="line.461"></a>
<FONT color="green">462</FONT>            writer.print(postfix);<a name="line.462"></a>
<FONT color="green">463</FONT>            writer.flush();<a name="line.463"></a>
<FONT color="green">464</FONT>        }<a name="line.464"></a>
<FONT color="green">465</FONT>        <a name="line.465"></a>
<FONT color="green">466</FONT>        /* (non-Javadoc)<a name="line.466"></a>
<FONT color="green">467</FONT>         * @see ch.javasoft.smx.iface.MatrixBase#clone()<a name="line.467"></a>
<FONT color="green">468</FONT>         */<a name="line.468"></a>
<FONT color="green">469</FONT>        @Override<a name="line.469"></a>
<FONT color="green">470</FONT>            public DefaultLongMatrix clone() {<a name="line.470"></a>
<FONT color="green">471</FONT>            return new DefaultLongMatrix(mValues.clone(), -1, mColumnCount);<a name="line.471"></a>
<FONT color="green">472</FONT>        }<a name="line.472"></a>
<FONT color="green">473</FONT>        public DefaultLongMatrix newInstance(int rows, int cols) {<a name="line.473"></a>
<FONT color="green">474</FONT>            return new DefaultLongMatrix(rows, cols);<a name="line.474"></a>
<FONT color="green">475</FONT>        }<a name="line.475"></a>
<FONT color="green">476</FONT>        <a name="line.476"></a>
<FONT color="green">477</FONT>        public DefaultLongMatrix newInstance(Long[][] data, boolean rowsInDim1) {<a name="line.477"></a>
<FONT color="green">478</FONT>            final int rows, cols;<a name="line.478"></a>
<FONT color="green">479</FONT>            if (rowsInDim1) {<a name="line.479"></a>
<FONT color="green">480</FONT>                    rows = data.length;<a name="line.480"></a>
<FONT color="green">481</FONT>                    cols = rows == 0 ? 0 : data[0].length;<a name="line.481"></a>
<FONT color="green">482</FONT>            }<a name="line.482"></a>
<FONT color="green">483</FONT>            else {<a name="line.483"></a>
<FONT color="green">484</FONT>                    cols = data.length;<a name="line.484"></a>
<FONT color="green">485</FONT>                    rows = cols == 0 ? 0 : data[0].length;<a name="line.485"></a>
<FONT color="green">486</FONT>            }<a name="line.486"></a>
<FONT color="green">487</FONT>            final long[] values = new long[rows * cols];<a name="line.487"></a>
<FONT color="green">488</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.488"></a>
<FONT color="green">489</FONT>                            for (int col = 0; col &lt; cols; col++) {<a name="line.489"></a>
<FONT color="green">490</FONT>                                    final Long val = rowsInDim1 ? data[row][col] : data[col][row];<a name="line.490"></a>
<FONT color="green">491</FONT>                                    values[row * cols + col] = val.longValue();<a name="line.491"></a>
<FONT color="green">492</FONT>                            }<a name="line.492"></a>
<FONT color="green">493</FONT>                    }<a name="line.493"></a>
<FONT color="green">494</FONT>            return new DefaultLongMatrix(values, rows, cols);<a name="line.494"></a>
<FONT color="green">495</FONT>        }<a name="line.495"></a>
<FONT color="green">496</FONT>        <a name="line.496"></a>
<FONT color="green">497</FONT>        public LongMatrix toLongMatrix(boolean enforceNewInstance) {<a name="line.497"></a>
<FONT color="green">498</FONT>            return enforceNewInstance ? (LongMatrix)clone() : this;<a name="line.498"></a>
<FONT color="green">499</FONT>        }<a name="line.499"></a>
<FONT color="green">500</FONT>        <a name="line.500"></a>
<FONT color="green">501</FONT>        public LongMatrix toWritableMatrix(boolean enforceNewInstance) {<a name="line.501"></a>
<FONT color="green">502</FONT>            return toLongMatrix(enforceNewInstance);<a name="line.502"></a>
<FONT color="green">503</FONT>        }<a name="line.503"></a>
<FONT color="green">504</FONT>        public LongMatrix toReadableMatrix(boolean enforceNewInstance) {<a name="line.504"></a>
<FONT color="green">505</FONT>            return toLongMatrix(enforceNewInstance);<a name="line.505"></a>
<FONT color="green">506</FONT>        }<a name="line.506"></a>
<FONT color="green">507</FONT>        <a name="line.507"></a>
<FONT color="green">508</FONT>        public LongRationalMatrix toLongRationalMatrix(boolean enforceNewInstance) {<a name="line.508"></a>
<FONT color="green">509</FONT>            // TODO impl<a name="line.509"></a>
<FONT color="green">510</FONT>            throw new RuntimeException("not implemented yet");<a name="line.510"></a>
<FONT color="green">511</FONT>        }<a name="line.511"></a>
<FONT color="green">512</FONT>    <a name="line.512"></a>
<FONT color="green">513</FONT>        public BigIntegerRationalMatrix toBigIntegerRationalMatrix(boolean enforceNewInstance) {<a name="line.513"></a>
<FONT color="green">514</FONT>            return new DefaultBigIntegerRationalMatrix(toLongArray(), getRowCount(), getColumnCount()); <a name="line.514"></a>
<FONT color="green">515</FONT>        }<a name="line.515"></a>
<FONT color="green">516</FONT>        <a name="line.516"></a>
<FONT color="green">517</FONT>        public DoubleMatrix toDoubleMatrix(boolean enforceNewInstance) {<a name="line.517"></a>
<FONT color="green">518</FONT>            return new DefaultDoubleMatrix(toDoubleArray(), getRowCount(), getColumnCount());<a name="line.518"></a>
<FONT color="green">519</FONT>        }<a name="line.519"></a>
<FONT color="green">520</FONT>        <a name="line.520"></a>
<FONT color="green">521</FONT>        public void addRowToOtherRow(int srcRow, int srcFactor, int dstRow, int dstFactor) {<a name="line.521"></a>
<FONT color="green">522</FONT>            addRowToOtherRow(srcRow, (long)srcFactor, dstRow, (long)dstFactor);<a name="line.522"></a>
<FONT color="green">523</FONT>        }<a name="line.523"></a>
<FONT color="green">524</FONT>        public void addRowToOtherRow(int srcRow, long srcFactor, int dstRow, long dstFactor) {        <a name="line.524"></a>
<FONT color="green">525</FONT>            final int cols = getColumnCount();<a name="line.525"></a>
<FONT color="green">526</FONT>            for (int col = 0; col &lt; cols; col++) {<a name="line.526"></a>
<FONT color="green">527</FONT>                setValueAt(dstRow, col, dstFactor * getLongValueAt(dstRow, col) + srcFactor * getLongValueAt(srcRow, col));<a name="line.527"></a>
<FONT color="green">528</FONT>            }<a name="line.528"></a>
<FONT color="green">529</FONT>        }<a name="line.529"></a>
<FONT color="green">530</FONT>        <a name="line.530"></a>
<FONT color="green">531</FONT>        public void add(int row, int col, int value) {<a name="line.531"></a>
<FONT color="green">532</FONT>            add(row, col, (long)value);<a name="line.532"></a>
<FONT color="green">533</FONT>        }<a name="line.533"></a>
<FONT color="green">534</FONT>        public void add(int row, int col, long value) {<a name="line.534"></a>
<FONT color="green">535</FONT>            setValueAt(row, col, getLongValueAt(row, col) + value);<a name="line.535"></a>
<FONT color="green">536</FONT>        }<a name="line.536"></a>
<FONT color="green">537</FONT>        <a name="line.537"></a>
<FONT color="green">538</FONT>        public void multiply(int row, int col, int factor) {<a name="line.538"></a>
<FONT color="green">539</FONT>            multiply(row, col, (long)factor);<a name="line.539"></a>
<FONT color="green">540</FONT>        }<a name="line.540"></a>
<FONT color="green">541</FONT>        public void multiply(int row, int col, long factor) {<a name="line.541"></a>
<FONT color="green">542</FONT>            setValueAt(row, col, factor * getLongValueAt(row, col));<a name="line.542"></a>
<FONT color="green">543</FONT>        }<a name="line.543"></a>
<FONT color="green">544</FONT>        <a name="line.544"></a>
<FONT color="green">545</FONT>        public void multiplyRow(int row, int factor) {<a name="line.545"></a>
<FONT color="green">546</FONT>            multiplyRow(row, (long)factor);<a name="line.546"></a>
<FONT color="green">547</FONT>        }<a name="line.547"></a>
<FONT color="green">548</FONT>        public void multiplyRow(int row, long factor) {<a name="line.548"></a>
<FONT color="green">549</FONT>            int cols = getColumnCount();<a name="line.549"></a>
<FONT color="green">550</FONT>            for (int col = 0; col &lt; cols; col++) {<a name="line.550"></a>
<FONT color="green">551</FONT>                multiply(row, col, factor);<a name="line.551"></a>
<FONT color="green">552</FONT>            }<a name="line.552"></a>
<FONT color="green">553</FONT>        }<a name="line.553"></a>
<FONT color="green">554</FONT>        <a name="line.554"></a>
<FONT color="green">555</FONT>        @Override<a name="line.555"></a>
<FONT color="green">556</FONT>            public int hashCode() {<a name="line.556"></a>
<FONT color="green">557</FONT>            int value = mColumnCount;<a name="line.557"></a>
<FONT color="green">558</FONT>            for (int ii = 0; ii &lt; mValues.length; ii++) {<a name="line.558"></a>
<FONT color="green">559</FONT>                    value ^= (int)(mValues[ii] ^ (mValues[ii] &gt;&gt;&gt; 32));<a name="line.559"></a>
<FONT color="green">560</FONT>            }<a name="line.560"></a>
<FONT color="green">561</FONT>            return value;<a name="line.561"></a>
<FONT color="green">562</FONT>        }<a name="line.562"></a>
<FONT color="green">563</FONT>        <a name="line.563"></a>
<FONT color="green">564</FONT>        @Override<a name="line.564"></a>
<FONT color="green">565</FONT>            public boolean equals(Object obj) {<a name="line.565"></a>
<FONT color="green">566</FONT>            if (obj == this) return true;<a name="line.566"></a>
<FONT color="green">567</FONT>            if (obj == null) return false;<a name="line.567"></a>
<FONT color="green">568</FONT>            if (obj instanceof LongMatrix) {<a name="line.568"></a>
<FONT color="green">569</FONT>                final LongMatrix other = (LongMatrix)obj;<a name="line.569"></a>
<FONT color="green">570</FONT>                final int rows = getRowCount();<a name="line.570"></a>
<FONT color="green">571</FONT>                if (rows != other.getRowCount()) return false;<a name="line.571"></a>
<FONT color="green">572</FONT>                final int cols = getColumnCount();<a name="line.572"></a>
<FONT color="green">573</FONT>                if (cols != other.getColumnCount()) return false;<a name="line.573"></a>
<FONT color="green">574</FONT>                for (int row = 0; row &lt; rows; row++) {<a name="line.574"></a>
<FONT color="green">575</FONT>                    for (int col = 0; col &lt; cols; col++) {<a name="line.575"></a>
<FONT color="green">576</FONT>                        if (getLongValueAt(row, col) != other.getLongValueAt(row, col)) return false;<a name="line.576"></a>
<FONT color="green">577</FONT>                    }<a name="line.577"></a>
<FONT color="green">578</FONT>                }<a name="line.578"></a>
<FONT color="green">579</FONT>                return true;<a name="line.579"></a>
<FONT color="green">580</FONT>            }<a name="line.580"></a>
<FONT color="green">581</FONT>            return false;<a name="line.581"></a>
<FONT color="green">582</FONT>        }<a name="line.582"></a>
<FONT color="green">583</FONT>        <a name="line.583"></a>
<FONT color="green">584</FONT>        public LongMatrix subLongMatrix(int rowStart, int rowEnd, int colStart, int colEnd) {<a name="line.584"></a>
<FONT color="green">585</FONT>            final DefaultLongMatrix res = new DefaultLongMatrix(rowEnd - rowStart, colEnd - colStart);<a name="line.585"></a>
<FONT color="green">586</FONT>            for (int row = 0; row &lt; res.getRowCount(); row++) {<a name="line.586"></a>
<FONT color="green">587</FONT>                            for (int col = 0; col &lt; res.getColumnCount(); col++) {<a name="line.587"></a>
<FONT color="green">588</FONT>                                    res.setValueAt(row, col, getLongValueAt(rowStart + row, colStart + col));<a name="line.588"></a>
<FONT color="green">589</FONT>                            }<a name="line.589"></a>
<FONT color="green">590</FONT>                    }<a name="line.590"></a>
<FONT color="green">591</FONT>            return res;<a name="line.591"></a>
<FONT color="green">592</FONT>        }<a name="line.592"></a>
<FONT color="green">593</FONT>        public LongRationalMatrix subLongRationalMatrix(int rowStart, int rowEnd, int colStart, int colEnd) {<a name="line.593"></a>
<FONT color="green">594</FONT>            return subLongMatrix(rowStart, rowEnd, colStart, colEnd).toLongRationalMatrix(false /*cloned anyway*/);<a name="line.594"></a>
<FONT color="green">595</FONT>        }<a name="line.595"></a>
<FONT color="green">596</FONT>        public BigIntegerRationalMatrix subBigIntegerRationalMatrix(int rowStart, int rowEnd, int colStart, int colEnd) {<a name="line.596"></a>
<FONT color="green">597</FONT>            return subLongMatrix(rowStart, rowEnd, colStart, colEnd).toBigIntegerRationalMatrix(false /*cloned anyway*/);<a name="line.597"></a>
<FONT color="green">598</FONT>        }<a name="line.598"></a>
<FONT color="green">599</FONT>        public DoubleMatrix subDoubleMatrix(int rowStart, int rowEnd, int colStart, int colEnd) {<a name="line.599"></a>
<FONT color="green">600</FONT>            return subLongMatrix(rowStart, rowEnd, colStart, colEnd).toDoubleMatrix(false /*clonded anyway*/);<a name="line.600"></a>
<FONT color="green">601</FONT>        }<a name="line.601"></a>
<FONT color="green">602</FONT>        public ReadableBigIntegerMatrix subBigIntegerMatrix(int rowStart, int rowEnd, int colStart, int colEnd) {<a name="line.602"></a>
<FONT color="green">603</FONT>            return subLongMatrix(rowStart, rowEnd, colStart, colEnd).toBigIntegerMatrix(false /*clonded anyway*/);<a name="line.603"></a>
<FONT color="green">604</FONT>        }<a name="line.604"></a>
<FONT color="green">605</FONT>        public DefaultLongMatrix transpose() {<a name="line.605"></a>
<FONT color="green">606</FONT>            final int rows = getRowCount();<a name="line.606"></a>
<FONT color="green">607</FONT>            final int cols = getColumnCount();<a name="line.607"></a>
<FONT color="green">608</FONT>            final DefaultLongMatrix tr = new DefaultLongMatrix(cols, rows);<a name="line.608"></a>
<FONT color="green">609</FONT>            for (int row = 0; row &lt; rows; row++) {<a name="line.609"></a>
<FONT color="green">610</FONT>                            for (int col = 0; col &lt; cols; col++) {<a name="line.610"></a>
<FONT color="green">611</FONT>                                    tr.setValueAt(col, row, getLongValueAt(row, col));<a name="line.611"></a>
<FONT color="green">612</FONT>                            }<a name="line.612"></a>
<FONT color="green">613</FONT>                    }<a name="line.613"></a>
<FONT color="green">614</FONT>            return tr;<a name="line.614"></a>
<FONT color="green">615</FONT>        }<a name="line.615"></a>
<FONT color="green">616</FONT>    <a name="line.616"></a>
<FONT color="green">617</FONT>            public BigInteger getBigIntegerValueAt(int row, int col) {<a name="line.617"></a>
<FONT color="green">618</FONT>                    return BigInteger.valueOf(getLongValueAt(row, col));<a name="line.618"></a>
<FONT color="green">619</FONT>            }<a name="line.619"></a>
<FONT color="green">620</FONT>    <a name="line.620"></a>
<FONT color="green">621</FONT>            public void toArray(BigInteger[] array) {<a name="line.621"></a>
<FONT color="green">622</FONT>            if (array.length != mValues.length) {<a name="line.622"></a>
<FONT color="green">623</FONT>                throw new IllegalArgumentException("expected array length " + mValues.length + " but found " + array.length);<a name="line.623"></a>
<FONT color="green">624</FONT>            }<a name="line.624"></a>
<FONT color="green">625</FONT>                    for (int i = 0; i &lt; array.length; i++) {<a name="line.625"></a>
<FONT color="green">626</FONT>                            array[i] = BigInteger.valueOf(mValues[i]);<a name="line.626"></a>
<FONT color="green">627</FONT>                    }<a name="line.627"></a>
<FONT color="green">628</FONT>            }<a name="line.628"></a>
<FONT color="green">629</FONT>    <a name="line.629"></a>
<FONT color="green">630</FONT>            public BigInteger[] toBigIntegerArray() {<a name="line.630"></a>
<FONT color="green">631</FONT>            final BigInteger[] array = new BigInteger[mValues.length];<a name="line.631"></a>
<FONT color="green">632</FONT>            toArray(array);<a name="line.632"></a>
<FONT color="green">633</FONT>            return array;<a name="line.633"></a>
<FONT color="green">634</FONT>            }<a name="line.634"></a>
<FONT color="green">635</FONT>    <a name="line.635"></a>
<FONT color="green">636</FONT>            public BigIntegerMatrix toBigIntegerMatrix(boolean enforceNewInstance) {<a name="line.636"></a>
<FONT color="green">637</FONT>                    return new DefaultBigIntegerMatrix(this);<a name="line.637"></a>
<FONT color="green">638</FONT>            }<a name="line.638"></a>
<FONT color="green">639</FONT>        <a name="line.639"></a>
<FONT color="green">640</FONT>            public BigInteger[] getBigIntegerColumn(int col) {<a name="line.640"></a>
<FONT color="green">641</FONT>            final BigInteger[] theCol = new BigInteger[getRowCount()];<a name="line.641"></a>
<FONT color="green">642</FONT>            for (int row = 0; row &lt; theCol.length; row++) {<a name="line.642"></a>
<FONT color="green">643</FONT>                            theCol[row] = getBigIntegerValueAt(row, col);<a name="line.643"></a>
<FONT color="green">644</FONT>                    }<a name="line.644"></a>
<FONT color="green">645</FONT>            return theCol;<a name="line.645"></a>
<FONT color="green">646</FONT>            }<a name="line.646"></a>
<FONT color="green">647</FONT>    <a name="line.647"></a>
<FONT color="green">648</FONT>            public BigInteger[][] getBigIntegerColumns() {<a name="line.648"></a>
<FONT color="green">649</FONT>            final BigInteger[][] cols = new BigInteger[getColumnCount()][];<a name="line.649"></a>
<FONT color="green">650</FONT>            for (int col = 0; col &lt; cols.length; col++) {<a name="line.650"></a>
<FONT color="green">651</FONT>                            cols[col] = getBigIntegerColumn(col);<a name="line.651"></a>
<FONT color="green">652</FONT>                    }<a name="line.652"></a>
<FONT color="green">653</FONT>            return cols;<a name="line.653"></a>
<FONT color="green">654</FONT>            }<a name="line.654"></a>
<FONT color="green">655</FONT>    <a name="line.655"></a>
<FONT color="green">656</FONT>            public BigInteger[] getBigIntegerRow(int row) {<a name="line.656"></a>
<FONT color="green">657</FONT>            final BigInteger[] theRow = new BigInteger[getColumnCount()];<a name="line.657"></a>
<FONT color="green">658</FONT>            for (int col = 0; col &lt; theRow.length; col++) {<a name="line.658"></a>
<FONT color="green">659</FONT>                    theRow[col] = getBigIntegerValueAt(row, col);<a name="line.659"></a>
<FONT color="green">660</FONT>                    }<a name="line.660"></a>
<FONT color="green">661</FONT>            return theRow;<a name="line.661"></a>
<FONT color="green">662</FONT>            }<a name="line.662"></a>
<FONT color="green">663</FONT>    <a name="line.663"></a>
<FONT color="green">664</FONT>            public BigInteger[][] getBigIntegerRows() {<a name="line.664"></a>
<FONT color="green">665</FONT>            final BigInteger[][] rows = new BigInteger[getRowCount()][];<a name="line.665"></a>
<FONT color="green">666</FONT>            for (int row = 0; row &lt; rows.length; row++) {<a name="line.666"></a>
<FONT color="green">667</FONT>                    rows[row] = getBigIntegerRow(row);<a name="line.667"></a>
<FONT color="green">668</FONT>                    }<a name="line.668"></a>
<FONT color="green">669</FONT>            return rows;<a name="line.669"></a>
<FONT color="green">670</FONT>            }<a name="line.670"></a>
<FONT color="green">671</FONT>            public void negate(int row, int col) {<a name="line.671"></a>
<FONT color="green">672</FONT>                    setValueAt(row, col, -getLongValueAt(row, col));<a name="line.672"></a>
<FONT color="green">673</FONT>            }<a name="line.673"></a>
<FONT color="green">674</FONT>    <a name="line.674"></a>
<FONT color="green">675</FONT>    }<a name="line.675"></a>




























































</PRE>
</BODY>
</HTML>
